\ LIS3DH-Example on MAX1000 with K1/SMAF

\ Support Routines
  : acc_wait    ( -- ) \ wait till Accelerometer is ready
    BEGIN acc_data @  0< 0= UNTIL ;

  : acc_on      ( -- ) \ Reset CS to 0, if not still 0
    acc_data @  $100 and IF 0 acc_data ! THEN ;
  : acc_off     ( -- ) \ Set CS to 1
    $100 acc_data ! ;

  : (acc!       ( data -- ) \ write to Accelerometer
    acc_wait   acc_data !   acc_wait ;
  : (acc@       ( -- data ) \ read from Accerometer
    0 (acc!   acc_data @  $ff and ;
  : acc!        ( data addr -- ) \ write register
    acc_on   (acc!   (acc!   acc_off ;
  : acc@        ( addr -- data ) \ read register (Bit 7=1)
    acc_on   $80 or  (acc!   (acc@   acc_off ;

\ Init and read xyz
  : acc_init    ( -- ) \ Test: 100 Hz XYZ
    $57 $20 acc!   \ CTRL_REG1: 100Hz; X,Y,Z activ
    $08 $23 acc! ; \ CTRL_REG4: 2g; High-Resolution

  : acc_xyz     ( -- x y z ) \ Read data
    acc_on   $e8 (acc! \ Set address to OUT_X_L and increment
    3 FOR
      (acc@  (acc@ flip  or
    NEXT
    acc_off ;

  : show_acc    ( -- ) \ Display till button pressed
    acc_init  base @  hex
    BEGIN
      BEGIN $27 acc@  $08 and UNTIL \ Wait for data
      acc_xyz  cr  3 FOR 4 0u.r space NEXT \ Display data  
      $27 acc@  2 0u.r  space   button?
    UNTIL base ! ;
    